package com.tibco.streambase.example.test;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import com.streambase.sb.unittest.Expecter;
import com.streambase.sb.unittest.JSONSingleQuotesTupleMaker;
import com.streambase.sb.unittest.SBServerManager;
import com.streambase.sb.unittest.ServerManagerFactory;

public class TestOneCreditScore {

	private static SBServerManager server;

	@BeforeClass
	public static void setupServer() throws Exception {
		// create a StreamBase server and load applications once for all tests in this class
		server = ServerManagerFactory.getEmbeddedServer();
		server.startServer();
		server.loadApp("com.tibco.streambase.example.example_pfa_titus_python.example-PFA-credit-scoring-titus");
	}

	@AfterClass
	public static void stopServer() throws Exception {
		if (server != null) {
			server.shutdownServer();
			server = null;
		}
	}

	@Before
	public void startContainers() throws Exception {
		// before each test, startup fresh container instances
		server.startContainers();
	}

	@Test
	public void test1() throws Exception {
		server.getEnqueuer("CreditScoringIn").enqueue(JSONSingleQuotesTupleMaker.MAKER,
				"{'income':'3730','ninetydayslate':'0','revolve_util':'0.28','debt_ratio':'0.21','credit_lines':'7','thirtydayslate':'0','delinquent':'No','state':'NY','id':'99947','name':'Ana Vaughn','age':'33','num_dep':'3','edu':'5'}");
		new Expecter(server.getDequeuer("CreditScores")).expect(JSONSingleQuotesTupleMaker.MAKER,
				"{'INFO':{'Yes':0.0134739407952994,'No':0.9865260592047006},'PRED':'No','CONF':0.9865260592047006}");
	}

	@After
	public void stopContainers() throws Exception {
		// after each test, dispose of the container instances
		server.stopContainers();
	}

}
